(function(){var P$=Clazz.newPackage("jalview.ws.ebi"),I$=[[0,'Error','jalview.util.MessageManager','java.io.File','StringBuilder','java.util.StringTokenizer','java.net.URL','java.io.BufferedInputStream','java.io.FileOutputStream','java.io.BufferedReader','java.io.InputStreamReader','java.util.ArrayList']],$I$=function(i){return I$[i]||(I$[i]=Clazz.load(I$[0][i]))};
var C$=Clazz.newClass(P$, "EBIFetchClient");

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$', function () {
C$.$init$.apply(this);
}, 1);

Clazz.newMeth(C$, 'getSupportedDBs$', function () {
throw Clazz.new_(Clazz.load('Error').c$$S,[Clazz.load('jalview.util.MessageManager').getString$S("error.not_yet_implemented")]);
});

Clazz.newMeth(C$, 'getSupportedFormats$', function () {
throw Clazz.new_($I$(1).c$$S,[$I$(2).getString$S("error.not_yet_implemented")]);
});

Clazz.newMeth(C$, 'getSupportedStyles$', function () {
throw Clazz.new_($I$(1).c$$S,[$I$(2).getString$S("error.not_yet_implemented")]);
});

Clazz.newMeth(C$, 'fetchDataAsFile$S$S$S', function (ids, format, ext) {
var outFile=null;
try {
outFile=Clazz.load('java.io.File').createTempFile$S$S("jalview", "." + ext);
outFile.deleteOnExit$();
this.fetchData$S$S$java_io_File(ids, format, outFile);
if (outFile.length$() == 0) {
outFile.delete$();
return null;
}} catch (ex) {
if (Clazz.exceptionOf(ex,"Exception")){
} else {
throw ex;
}
}
return outFile;
});

Clazz.newMeth(C$, 'fetchData$S$S$java_io_File', function (ids, format, outFile) {
var querystring=Clazz.new_(Clazz.load('StringBuilder').c$$I,[ids.length$()]);
var database=C$.parseIds$S$StringBuilder(ids, querystring);
if (database == null ) {
System.err.println$S("Invalid Query string : '" + ids + "'" );
System.err.println$S("Should be of form \'dbname:q1;q2;q3;q4\'");
return null;
}var rslt=this.fetchBatch$S$S$S$java_io_File(querystring.toString(), database, format, outFile);
return (rslt != null  && rslt.length > 0  ? rslt : null);
});

Clazz.newMeth(C$, 'parseIds$S$StringBuilder', function (ids, queryString) {
var database=null;
var queries=Clazz.new_(Clazz.load('java.util.StringTokenizer').c$$S$S,[ids, ";"]);
var appending=queryString.length$() > 0;
while (queries.hasMoreTokens$()){
var query=queries.nextToken$();
var p=query.indexOf$I(":");
if (p > -1) {
var db=query.substring$I$I(0, p);
if (database != null  && !db.equalsIgnoreCase$S(database) ) {
return null;
}database=db;
query=query.substring$I(p + 1);
}queryString.append$S(appending ? "," : "");
queryString.append$S(query);
appending=true;
}
return database;
}, 1);

Clazz.newMeth(C$, 'fetchBatch$S$S$S$java_io_File', function (ids, database, format, outFile) {
var url=C$.buildUrl$S$S$S(ids, database, format);
try {
var rcall=Clazz.new_(Clazz.load('java.net.URL').c$$S,[url]);
var conn=rcall.openConnection$();
var responseCode=conn.getResponseCode$();
if (responseCode != 200) {
System.err.println$S("Warning: response code " + responseCode + " for " + url );
}var is=Clazz.new_(Clazz.load('java.io.BufferedInputStream').c$$java_io_InputStream,[conn.getInputStream$()]);
if (outFile != null ) {

if (outFile._isTemp) { outFile._bytes = is.$in.$in.buf;
return null;
}
var fio=Clazz.new_(Clazz.load('java.io.FileOutputStream').c$$java_io_File,[outFile]);
var bb=Clazz.array(Byte.TYPE, [32768]);
var l;
while ((l=is.read$BA(bb)) > 0){
fio.write$BA$I$I(bb, 0, l);
}
fio.close$();
is.close$();
} else {
var br=Clazz.new_(Clazz.load('java.io.BufferedReader').c$$java_io_Reader,[Clazz.new_(Clazz.load('java.io.InputStreamReader').c$$java_io_InputStream,[is])]);
var rtn;
var arl=Clazz.new_(Clazz.load('java.util.ArrayList'));
while ((rtn=br.readLine$()) != null ){
arl.add$TE(rtn);
}
return arl.toArray$TTA(Clazz.array(String, [arl.size$()]));
}} catch (e$$) {
if (Clazz.exceptionOf(e$$,"OutOfMemoryError")){
var er = e$$;
{
System.out.println$S("OUT OF MEMORY DOWNLOADING QUERY FROM " + database + ":\n" + ids );
throw er;
}
} else if (Clazz.exceptionOf(e$$,"Exception")){
var ex = e$$;
{
if (ex.getMessage$().startsWith$S("uk.ac.ebi.jdbfetch.exceptions.DbfNoEntryFoundException")) {
return null;
}System.err.println$S("Unexpected exception when retrieving from " + database + "\nQuery was : '" + ids + "'" );
ex.printStackTrace$java_io_PrintStream(System.err);
return null;
}
} else {
throw e$$;
}
} finally {
}
return null;
});

Clazz.newMeth(C$, 'buildUrl$S$S$S', function (ids, database, format) {
var url;
if (database.equalsIgnoreCase$S("EMBL") || database.equalsIgnoreCase$S("EMBLCDS") ) {
url="https://www.ebi.ac.uk/ena/data/view/" + ids.toLowerCase$() + (format != null  ? "&" + format : "") ;
} else {
url="https://www.ebi.ac.uk/Tools/dbfetch/dbfetch/" + database.toLowerCase$() + "/" + ids.toLowerCase$() + (format != null  ? "/" + format : "") ;
}return url;
}, 1);
})();
;Clazz.setTVer('3.2.2.04');//Created 2018-08-26 06:33:46 Java2ScriptVisitor version 3.2.2.04 net.sf.j2s.core.jar version 3.2.2.04
